
//Thanks hiroi01!

#include "common.h"



#define CHEACK_KEY_2 (PSP_CTRL_SELECT | PSP_CTRL_START | PSP_CTRL_UP | PSP_CTRL_RIGHT | \
    PSP_CTRL_DOWN | PSP_CTRL_LEFT | PSP_CTRL_LTRIGGER | PSP_CTRL_RTRIGGER | PSP_CTRL_TRIANGLE | \
    PSP_CTRL_CIRCLE | PSP_CTRL_CROSS | PSP_CTRL_SQUARE | PSP_CTRL_NOTE | PSP_CTRL_HOME | \
	PSP_CTRL_SCREEN | PSP_CTRL_VOLUP | PSP_CTRL_VOLDOWN )

void get_button(SceCtrlData *data)
{
  sceCtrlPeekBufferPositive( data, 1 );
  data->Buttons &= CHEACK_KEY_2;
}


void wait_button_up(SceCtrlData *data)
{
  while((data->Buttons & CHEACK_KEY_2) != 0)
  {
	sceKernelDelayThread( 1000 );
    sceCtrlPeekBufferPositive( data, 1 );
  }

}

int minimenu(bool flag)
{
	SceCtrlData pad;
	int pos = 0;
	int char_high = jpn0->advancey * jpn0->size * 0.25 +2;
	guStart();
	fillScreenRect(SILVER, 350 , 150 , 120 , 100);
	printf_j(365, 150 + 1*(char_high), flag ? "Rs[" : "\\t");
	printf_j(365, 150 + 2*(char_high), "폜");
	printf_j(365, 150 + 3*(char_high), "l[");
	printf_j(365, 150 + 4*(char_high), "tH_쐬");
	printf_j(355, 150+char_high + pos*(char_high), ">");
	guEnd();
	
	while(1)
	{
		sceKernelDelayThread( 1000 );
		get_button(&pad);
		if(pad.Buttons & (PSP_CTRL_UP|PSP_CTRL_DOWN))
		{
			guStart();
			fillScreenRect(SILVER, 350 , 150 + pos*(char_high) , 15 , 18);
			pos += (((int)((pad.Buttons&(PSP_CTRL_UP|PSP_CTRL_DOWN))-40))/24);
			if(pos < 0) pos = 3;
			if(pos > 3) pos = 0;
			printf_j(355, 150+char_high + pos*(char_high), ">");
			guEnd();
			sceKernelDelayThread( 150*1000 );
		}
		else if( pad.Buttons & PSP_CTRL_CIRCLE )
		{
			break;
		}
		else if( pad.Buttons & PSP_CTRL_CROSS )
		{
			pos = -1;
			break;
		}
	}
	return pos;
}

/*
 (J[\)ł܂XN[悤ɂƂ}N
 ȂƂȂ֐łȂ}NŎĂ܂
 */
#define ALLORW_WAIT(button,firstWait,wait) \
if( (beforeButtons & (button) ) == (button) ){ \
	if( firstFlag ){ \
		if( (sceKernelLibcClock() - time) >= (firstWait) ){ \
			time = sceKernelLibcClock(); \
			firstFlag = false; \
		}else{ \
			continue; \
		} \
	}else{ \
		if( (sceKernelLibcClock() - time) >= (wait) ){ \
			time = sceKernelLibcClock(); \
		}else{ \
			continue; \
		} \
	} \
}else{ \
	firstFlag = true; \
	beforeButtons = button; \
	time = sceKernelLibcClock(); \
} \


const char *UNIT[] = {
	"B",
	"KB",
	"MB",
	"GB"
};


void conv_unit(u64 src, CONV *conv_list)
{
	float buf = src;
	int unit = 0;
	while(buf > 1024)
	{
		buf /= 1024;
		unit++;
	}
	conv_list->size = buf;
	conv_list->unit = unit;
}

int fileManager(const char *startPath, char *toPath, char *title, int *check, u64 size)
{
	dir_t *dirBuf = NULL;
	int dir_num=0,offset,i=0,now_arrow,tmp;
	u32 beforeButtons = 0;
	clock_t time = 0;
	DiskInfo MSInfo;
	CONV size_list[3];
	char currentPath[256], buf[256];
	bool firstFlag = true;
	int char_high = jpn0->advancey * jpn0->size * 0.25 +2;
	SceCtrlData pad;
	
	strcpy(currentPath,startPath);
	while(1){
		dirBuf = read_dir(currentPath, dirBuf, &dir_num);
		getDiskInfo(&MSInfo);
		conv_unit(MSInfo.sfree, &size_list[1]);
		conv_unit(MSInfo.smax, &size_list[2]);
		offset = 0;
		now_arrow = 0;


PRINT_LIST:
		clearScreen(WHITE);
		guStart();
		printf_j(470-intraFontMeasureText(jpn0, title), char_high, title);
		printf_j(15, char_high, "[%s]", currentPath);

		if( dir_num != 0 ){
			for( i = 0; i < dir_num && i < MAX_DISPLAY_NUM; i++ ){
				if( *dirBuf[i+offset].type == TYPE_DIR ){
					printf_j(15, char_high*2+3 + i*(char_high), "%s/",dirBuf[i+offset].name);
				}else
					printf_j(15, char_high*2+3 + i*(char_high), "%s",dirBuf[i+offset].name);
			}
			printf_j(5, char_high*2+3 + now_arrow*(char_high), ">");
			conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
			sprintf(buf, "%.2f", size_list[0].size);
			printf_j(80-intraFontMeasureText(jpn0, buf), 268, "%s %s", buf, UNIT[size_list[0].unit]);
		}
		sprintf(buf, "%d", dir_num);
		printf_j(185-intraFontMeasureText(jpn0, buf), 268, buf);
		printf_j(200, 268, "%.2f %s / %.2f %s", size_list[1].size, UNIT[size_list[1].unit],
			size_list[2].size, UNIT[size_list[2].unit]);
		guEnd();

		while(1){
			sceKernelDelayThread( 1000 );
			get_button(&pad);
			if(MScmIsMediumInserted() == 0)
			{
				strcpy(currentPath,startPath);
				int buf_time = 0;
				while(1)
				{
					while(MScmIsMediumInserted() == 0)sceKernelDelayThread( 100*1000 );
					sceKernelDelayThread( 2000*1000 );
					if(check != NULL){
						SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
						if (fp_check >= 0){
							sceIoRead(fp_check, &buf_time, sizeof(int));
						}
						sceIoClose(fp_check);
						if(buf_time != *check)
						{
							break;
						}
						print_message("XeBbNł");
						while(MScmIsMediumInserted() == 1)sceKernelDelayThread( 100*1000 );
						continue;
					}
					break;
				}
				break;
			}
			if( pad.Buttons & PSP_CTRL_DOWN )
			{
				ALLORW_WAIT(PSP_CTRL_DOWN,3 * 100 * 1000,1 * 100 * 1000);
				
				if( now_arrow + 1 < MAX_DISPLAY_NUM && now_arrow + 1 < dir_num ){
					guStart();
					fillScreenRect(WHITE, 5 , char_high*2+3 + (now_arrow-1)*(char_high) , 10 , 18);
					now_arrow++;
					printf_j(5, char_high*2+3 + now_arrow*(char_high), ">");
					conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
					fillScreenRect(WHITE, 15 , 268-char_high , 110 , char_high+4);
					sprintf(buf, "%.2f", size_list[0].size);
					printf_j(80-intraFontMeasureText(jpn0, buf), 268, "%s %s", buf, UNIT[size_list[0].unit]);
					guEnd();
				}else{
					if( offset+MAX_DISPLAY_NUM < dir_num ){
						offset++;
						goto PRINT_LIST;
					}
				}
			}
			else if( pad.Buttons & PSP_CTRL_UP )
			{
				ALLORW_WAIT(PSP_CTRL_UP,3 * 100 * 1000,1 * 100 * 1000);
				
				if( now_arrow - 1 >= 0 ){
					guStart();
					fillScreenRect(WHITE, 5 , char_high*2+3 + (now_arrow-1)*(char_high) , 10 , 18);
					now_arrow--;
					printf_j(5, char_high*2+3 + now_arrow*(char_high), ">");
					conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
					fillScreenRect(WHITE, 15 , 268-char_high , 110 , char_high+4);
					sprintf(buf, "%.2f", size_list[0].size);
					printf_j(80-intraFontMeasureText(jpn0, buf), 268, "%s %s", buf, UNIT[size_list[0].unit]);
					guEnd();
				}else{
					if( offset > 0 ){
						offset--;
						goto PRINT_LIST;
					}
				}
			}
			else if( pad.Buttons & PSP_CTRL_RIGHT )
			{
				ALLORW_WAIT(PSP_CTRL_RIGHT,2 * 100 * 1000,1 * 100 * 1000);

				fillScreenRect(WHITE, 5 , char_high*2+3 + (now_arrow-1)*(char_high) , 10 , 18);
				tmp = 0;
				for( i = 0; i < 5; i++ ){
					if( now_arrow + 1 < MAX_DISPLAY_NUM && now_arrow + 1 < dir_num ){
						now_arrow++;
					}else if( offset+MAX_DISPLAY_NUM < dir_num ){
						offset++;
						tmp = 1;
					}
				}
				if( tmp ) goto PRINT_LIST;
				guStart();
				printf_j(5, char_high*2+3 + now_arrow*(char_high), ">");
				conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
				fillScreenRect(WHITE, 15 , 268-char_high , 110 , char_high+4);
				sprintf(buf, "%.2f", size_list[0].size);
				printf_j(80-intraFontMeasureText(jpn0, buf), 268, "%s %s", buf, UNIT[size_list[0].unit]);
				guEnd();
				
			}
			else if( pad.Buttons & PSP_CTRL_LEFT )
			{
				ALLORW_WAIT(PSP_CTRL_LEFT,2 * 100 * 1000,1 * 100 * 1000);
				
				
				fillScreenRect(WHITE, 5 , char_high*2+3 + (now_arrow-1)*(char_high) , 10 , 18);
				tmp = 0;
				for( i = 0; i < 5; i++ ){
					if( now_arrow - 1 >= 0 ){
						now_arrow--;
					}else if( offset > 0 ){
						offset--;
						tmp = 1;
					}
				}
				if( tmp ) goto PRINT_LIST;
				guStart();
				printf_j(5, char_high*2+3 + now_arrow*(char_high), ">");
				conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
				fillScreenRect(WHITE, 15 , 268-char_high , 110 , char_high+4);
				sprintf(buf, "%.2f", size_list[0].size);
				printf_j(80-intraFontMeasureText(jpn0, buf), 268, "%s %s", buf, UNIT[size_list[0].unit]);
				guEnd();
			}
			else if( pad.Buttons & PSP_CTRL_CIRCLE )
			{
				beforeButtons = PSP_CTRL_CIRCLE;

				//ݒñtH_ł͂Ȃ
				if(  dir_num != 0 ){
					//Iꂽ̂tH_[
					if( *dirBuf[offset+now_arrow].type == TYPE_DIR ){
						strcat(currentPath,dirBuf[offset+now_arrow].name);
						strcat(currentPath,"/");
						wait_button_up(&pad);
						break;
					}
				}
				wait_button_up(&pad);
			}
			else if( pad.Buttons & PSP_CTRL_CROSS )
			{
				beforeButtons = PSP_CTRL_CROSS;
				
				wait_button_up(&pad);
				if( currentPath[strlen(currentPath) - 2] != ':' && currentPath[0] != '\0' ){
					*strrchr(currentPath, '/') = '\0';
					*(strrchr(currentPath, '/')+1) = '\0';
					break;
				}
			}
			else if( pad.Buttons & PSP_CTRL_TRIANGLE )
			{
				char *tmp; 
				beforeButtons = PSP_CTRL_TRIANGLE;
				strcat(currentPath,dirBuf[offset+now_arrow].name);
				switch(minimenu(check == NULL))
				{
					case 0:
						if(check != NULL && size > MSInfo.sfree)
						{
							print_message("eʂ܂B\nt@CAXeBbNςĂ");
							sceKernelDelayThread( 2000*1000 );
							break;
						} else {
							if(check != NULL && checkYesNo("̃XeBbNɌ肵܂H \n OK  LZ ~") == 0)break;
							strcpy(toPath, currentPath);
							mem_free(dirBuf);
							wait_button_up(&pad);
							return 0;
						}
					case 1:
						if(*dirBuf[offset+now_arrow].type == TYPE_DIR)
							RemoveDirectory(currentPath);
						else sceIoRemove(currentPath);
						break;
					case 2:
						FileRename(currentPath);
						break;
					case 3:
						tmp = strrchr(currentPath, '/');
						*tmp = '\0';
						CreateFolder(currentPath);
						*tmp = '/';
						break;
				}
				*(strrchr(currentPath, '/')+1) = '\0';
				wait_button_up(&pad);
				break;
			} else {
				beforeButtons = 0;
			}
//			wait_button_up(&pad);
		}
	}
	mem_free(dirBuf);
	return 1;
}
