
//Thanks hiroi01!

#include "io.h"



#define CHEACK_KEY_2 (PSP_CTRL_SELECT | PSP_CTRL_START | PSP_CTRL_UP | PSP_CTRL_RIGHT | \
    PSP_CTRL_DOWN | PSP_CTRL_LEFT | PSP_CTRL_LTRIGGER | PSP_CTRL_RTRIGGER | PSP_CTRL_TRIANGLE | \
    DECISION_BUTTON | CANCEL_BUTTON | PSP_CTRL_SQUARE | PSP_CTRL_NOTE | PSP_CTRL_HOME | \
	PSP_CTRL_SCREEN | PSP_CTRL_VOLUP | PSP_CTRL_VOLDOWN )

/*
 (J[\)ł܂XN[悤ɂƂ}N
 ȂƂȂ֐łȂ}NŎĂ܂
 */
#define ALLORW_WAIT(button,firstWait,wait) \
if( (beforeButtons & (button) ) == (button) ){ \
	if( firstFlag ){ \
		if( (sceKernelLibcClock() - time) >= (firstWait) ){ \
			time = sceKernelLibcClock(); \
			firstFlag = false; \
		}else{ \
			continue; \
		} \
	}else{ \
		if( (sceKernelLibcClock() - time) >= (wait) ){ \
			time = sceKernelLibcClock(); \
		}else{ \
			continue; \
		} \
	} \
}else{ \
	firstFlag = true; \
	beforeButtons = button; \
	time = sceKernelLibcClock(); \
} \


const char *UNIT[] = {
	"B",
	"KB",
	"MB",
	"GB"
};

void get_button(SceCtrlData *data){
  sceCtrlPeekBufferPositive(data, 1);
  data->Buttons &= CHEACK_KEY_2;
}


void wait_button_up(SceCtrlData *data){
	while((data->Buttons & CHEACK_KEY_2) != 0){
		sceKernelDelayThread(1000);
		sceCtrlPeekBufferPositive(data, 1);
	}
}

int minimenu(bool flag, bool dir_exist){
	SceCtrlData pad;
	int i, pos;
	char *str[4];
	u32 beforeButtons = 0;
	clock_t time = 0;
	bool enable[4], firstFlag = true;

	str[0] = flag ? MINIMENU_PASTE : MINIMENU_COPY;
	str[1] = MINIMENU_DELETE;
	str[2] = MINIMENU_RENAME;
	str[3] = MINIMENU_MKFOLDER;
	enable[0] = flag|dir_exist;
	enable[1] = dir_exist;
	enable[2] = dir_exist;
	enable[3] = 1;
	for(i=0; i<4; i++){
		if(enable[i]){
			pos = i;
			break;
		}
	}
	libmFillRectEx(SILVER, 350 , 200 , 120 , 50);
	for(i=0; i<4; i++)libmPrintXY(365, 208 + i * LIST_CHAR_HEIGHT, enable[i] ? BLACK : LITEGRAY, 0, str[i]);
	libmPrintXY(355, 208 + pos * LIST_CHAR_HEIGHT, BLACK, 0, ">");
	
	while(1){
		sceKernelDelayThread( 1000 );
		get_button(&pad);
		if(pad.Buttons & (PSP_CTRL_UP|PSP_CTRL_DOWN)){
			ALLORW_WAIT(pad.Buttons & (PSP_CTRL_UP|PSP_CTRL_DOWN),3 * 100 * 1000,1 * 100 * 1000);
			libmFillRectEx(SILVER, 355, 208 + pos * LIST_CHAR_HEIGHT, 8 , 8);
			do {
				pos += (pad.Buttons & PSP_CTRL_UP) ? -1 : 1;
				if(pos < 0) pos = 3;
				if(pos > 3) pos = 0;
			} while(!enable[pos]);
			libmPrintXY(355, 208 + pos * LIST_CHAR_HEIGHT, BLACK, 0, ">");
			sceKernelDelayThread( 150*1000 );
		} else if( pad.Buttons & DECISION_BUTTON ){
			break;
		} else if( pad.Buttons & CANCEL_BUTTON ){
			pos = -1;
			break;
		} else {
			beforeButtons = 0;
		}

	}
	wait_button_up(&pad);
	return pos;
}



void conv_unit(u64 src, CONV *conv_list){
	float buf = src;
	int unit = 0;
	while(buf > 1024){
		buf /= 1024;
		unit++;
	}
	conv_list->size = buf;
	conv_list->unit = unit;
}


int fileManager(const char *startPath, char *toPath, dir_t **dir, int *check, u64 size){
	dir_t *dirBuf = NULL;
	int dir_num=0,offset,i=0,now_arrow,tmp;
	u32 beforeButtons = 0;
	clock_t time = 0;
	DiskInfo MSInfo;
	CONV size_list[3];
	char currentPath[256], buf[256];
	char *title = (check == NULL ? FILEMNGR_TITLE_SRC : FILEMNGR_TITLE_DEST);
	SceCtrlData pad;
	bool firstFlag = true;
	
	void PrintAllowAndSize(){
		libmFillRectEx(WHITE, 5 , LIST_POS , LIBM_CHAR_WIDTH , DETAIL_POS - LIST_POS);
		printf_j(5, LIST_POS + now_arrow*(LIST_CHAR_HEIGHT), ">");
		conv_unit(dirBuf[offset+now_arrow].size, &size_list[0]);
		libmFillRectEx(WHITE, 15 , DETAIL_POS , 110 , LIBM_CHAR_HEIGHT);
		sprintf(buf, "%.2f", size_list[0].size);
		printf_j(80-libmStrMeasure(buf), DETAIL_POS, "%s %s", buf, UNIT[size_list[0].unit]);
	}
	
	strcpy(currentPath,startPath);
	while(1){
		if(dirBuf != NULL)FreeVramAdder(dirBuf);
		dirBuf = read_dir(currentPath, &dir_num);
		getDiskInfo(&MSInfo);
		conv_unit(MSInfo.sfree, &size_list[1]);
		conv_unit(MSInfo.smax, &size_list[2]);
		offset = 0;
		now_arrow = 0;


PRINT_LIST:
		libmClearScreen(WHITE);
		printf_j(15, TITLE_POS, "[%s]", currentPath);
		printf_j(470-libmStrMeasure(title), TITLE_POS, title);

		if( dir_num != 0 ){
			for( i = 0; i < dir_num && i < MAX_DISPLAY_NUM; i++ ){
				printf_j(23, LIST_POS + i*LIST_CHAR_HEIGHT, (*dirBuf[i+offset].type == TYPE_DIR) ? "%s/" : "%s", dirBuf[i+offset].name);
				if(dirBuf[i+offset].copy)printf_j(15, LIST_POS + i*LIST_CHAR_HEIGHT, "*");
			}
			PrintAllowAndSize();
		}
		sprintf(buf, FILEMNGR_ITEM, dir_num);
		printf_j(185-libmStrMeasure(buf), DETAIL_POS, buf);
		printf_j(200, DETAIL_POS, "%.2f %s / %.2f %s", size_list[1].size, UNIT[size_list[1].unit],
			size_list[2].size, UNIT[size_list[2].unit]);

		while(1){
			sceKernelDelayThread(5000);
			get_button(&pad);
			if( pad.Buttons & PSP_CTRL_DOWN ){
				ALLORW_WAIT(PSP_CTRL_DOWN,3 * 100 * 1000,1 * 100 * 1000);
				
				if( now_arrow + 1 < MAX_DISPLAY_NUM && now_arrow + 1 < dir_num ){
					now_arrow++;
					PrintAllowAndSize();
				} else {
					if( offset+MAX_DISPLAY_NUM < dir_num ){
						offset++;
						goto PRINT_LIST;
					}
				}
			} else if( pad.Buttons & PSP_CTRL_UP ){
				ALLORW_WAIT(PSP_CTRL_UP,3 * 100 * 1000,1 * 100 * 1000);
				
				if( now_arrow - 1 >= 0 ){
					now_arrow--;
					PrintAllowAndSize();
				} else {
					if( offset > 0 ){
						offset--;
						goto PRINT_LIST;
					}
				}
			} else if( pad.Buttons & PSP_CTRL_RIGHT ){
				ALLORW_WAIT(PSP_CTRL_RIGHT,2 * 100 * 1000,1 * 100 * 1000);
				
				tmp = 0;
				for( i = 0; i < 5; i++ ){
					if( now_arrow + 1 < MAX_DISPLAY_NUM && now_arrow + 1 < dir_num ){
						now_arrow++;
					} else if( offset+MAX_DISPLAY_NUM < dir_num ){
						offset++;
						tmp = 1;
					}
				}
				if( tmp ) goto PRINT_LIST;
				PrintAllowAndSize();
			} else if( pad.Buttons & PSP_CTRL_LEFT ){
				ALLORW_WAIT(PSP_CTRL_LEFT,2 * 100 * 1000,1 * 100 * 1000);
				
				tmp = 0;
				for( i = 0; i < 5; i++ ){
					if( now_arrow - 1 >= 0 ){
						now_arrow--;
					} else if( offset > 0 ){
						offset--;
						tmp = 1;
					}
				}
				if( tmp ) goto PRINT_LIST;
				PrintAllowAndSize();
			} else if( pad.Buttons & DECISION_BUTTON ){
				beforeButtons = DECISION_BUTTON;

				//ݒñtH_ł͂Ȃ
				if(  dir_num != 0 ){
					//Iꂽ̂tH_[
					if( *dirBuf[offset+now_arrow].type == TYPE_DIR ){
						strcat(currentPath,dirBuf[offset+now_arrow].name);
						strcat(currentPath,"/");
						wait_button_up(&pad);
						break;
					}
				}
				wait_button_up(&pad);
			} else if( pad.Buttons & CANCEL_BUTTON ){
				beforeButtons = CANCEL_BUTTON;
				
				wait_button_up(&pad);
				if( currentPath[strlen(currentPath) - 2] != ':' && currentPath[0] != '\0' ){
					*strrchr(currentPath, '/') = '\0';
					*(strrchr(currentPath, '/')+1) = '\0';
					break;
				}
			} else if( pad.Buttons & PSP_CTRL_TRIANGLE ){
				char *tmp; 
				beforeButtons = PSP_CTRL_TRIANGLE;
				wait_button_up(&pad);
				int ret = minimenu(!!check, dir_num);
				if(ret < 0)goto PRINT_LIST;
				if(dir_num != 0)strcat(currentPath, dirBuf[offset+now_arrow].name);
				switch(ret){
					case 0:
						if(check != NULL && size > MSInfo.sfree){
							print_message(IS_NOT_ENOUGH_CAPACITY);
							sceKernelDelayThread(2000*1000);
							break;
						} else {
							if(check != NULL && checkYesNo(CHECK_DECIDE_FOLDER) < 0)break;
							*(strrchr(currentPath, '/')) = '\0';
							for( i = 0; i < dir_num; i++ ){
								if(dirBuf[i].copy)break;
							}
							if(i == dir_num)dirBuf[offset+now_arrow].copy = true;
							strcpy(toPath, currentPath);
							wait_button_up(&pad);
							if(dir != NULL)*dir = dirBuf;
							return dir_num;
						}
					case 1:
						if(checkYesNo(CHECK_DELETE_OBJECT) < 0)break;
						if(*dirBuf[offset+now_arrow].type == TYPE_DIR)
							RemoveDirectory(currentPath);
						else sceIoRemove(currentPath);
						break;
					case 2:
						FileRename(currentPath);
						break;
					case 3:
						tmp = strrchr(currentPath, '/');
						*tmp = '\0';
						CreateFolder(currentPath);
						*tmp = '/';
						break;
				}
				*(strrchr(currentPath, '/')+1) = '\0';
				break;
			} else if(check == NULL){
				if( pad.Buttons & PSP_CTRL_SQUARE && dir_num != 0 ){
					beforeButtons = PSP_CTRL_SQUARE;
					dirBuf[offset+now_arrow].copy ^= true;
					libmPutCharXY(15, LIST_POS + now_arrow*(LIST_CHAR_HEIGHT), BLACK, WHITE, dirBuf[offset+now_arrow].copy ? '*' : ' ');
					wait_button_up(&pad);
				} else if( pad.Buttons & PSP_CTRL_LTRIGGER ){
					beforeButtons = PSP_CTRL_LTRIGGER;
					for( i = 0; i < dir_num; i++ ){
						dirBuf[i].copy = false;
					}
					wait_button_up(&pad);
					goto PRINT_LIST;
				} else if( pad.Buttons & PSP_CTRL_RTRIGGER ){
					beforeButtons = PSP_CTRL_RTRIGGER;
					for( i = 0; i < dir_num; i++ ){
						dirBuf[i].copy = true;
					}
					wait_button_up(&pad);
					goto PRINT_LIST;
				} else {
					beforeButtons = 0;
				}
			} else {
				beforeButtons = 0;
			}
			
			//Check whether ms is in
			if(MSinserted == MS_CB_EVENT_EJECTED){
				strcpy(currentPath,startPath);
				print_message(MEMORYSTICK_INSERT);
				int buf_time = 0;
				while(1){
					while(MSinserted == MS_CB_EVENT_EJECTED)sceKernelDelayThread(100*1000);
					if(check != NULL){
						SceUID fp_check = sceIoOpen("ms0:/MS_check", PSP_O_RDONLY, 0777);
						if(fp_check >= 0){
							sceIoRead(fp_check, &buf_time, sizeof(int));
						}
						sceIoClose(fp_check);
						if(buf_time != *check){
							break;
						}
						print_message(MEMORYSTICK_SAME);
						while(MSinserted == MS_CB_EVENT_INSERTED){
							get_button(&pad);
							if(pad.Buttons & CANCEL_BUTTON){
								wait_button_up(&pad);
								FreeVramAdder(dirBuf);
								return -1;
							}
							sceKernelDelayThread( 100*1000 );
						}
						continue;
					}
					break;
				}
				break;
			}
		}
	}
	FreeVramAdder(dirBuf);
	return -1;
}
