/*
DadrfylibioQlɍDɘM܂B
䂤PSPTreeExplorer_1.1fix̃R[hς܂
*/
#include <string.h>

#include "io.h"


int RemoveDirectory(const char *path){
	SceUID dfd = sceIoDopen(path);

	SceIoDirent dir;
	memset(&dir, 0, sizeof(dir));

	while(0 < sceIoDread(dfd, &dir)){
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0){
			char *child = GetVramAdder(sizeof(char) * (strlen(path) + strlen(dir.d_name) + 2), 1);
			strcpy(child, path);
			strcat(child, "/");
			strcat(child, dir.d_name);
			if(dir.d_stat.st_attr & FIO_SO_IFDIR)
				RemoveDirectory(child);
			else{
				sceIoRemove(child);
			}
			FreeVramAdder(child);

			sceKernelDelayThread(1);
		}
		memset(&dir, 0, sizeof(dir));
	}
	sceIoDclose(dfd);
	
	sceIoRmdir(path);

	return 0;
}



u64 GetDirSize(const char *Name){
	u64 ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0){
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0){
			if(dir.d_stat.st_attr & FIO_SO_IFDIR){
				char *child = GetVramAdder(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2), 1);
				strcpy(child, Name);
				strcat(child, "/");
				strcat(child, dir.d_name);
				ret += GetDirSize(child);
				FreeVramAdder(child);
			}
			else
				ret += dir.d_stat.st_size;
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ret;
}

int GetDirCount(const char *Name, COUNT_TYPE opt){
	unsigned int ret = 0;
	SceIoDirent dir;
	memset(&dir, 0, sizeof(SceIoDirent));
	SceUID dfd = sceIoDopen(Name);

	while(sceIoDread(dfd, &dir) > 0){
		if(strlen(dir.d_name) && strcmp(dir.d_name, ".") != 0 && strcmp(dir.d_name, "..") != 0){
			if(dir.d_stat.st_attr & FIO_SO_IFDIR){
				if((opt & COUNT_ONCE) != COUNT_ONCE){
					char *child = GetVramAdder(sizeof(char) * (strlen(Name) + strlen(dir.d_name) + 2), 1);
					strcpy(child, Name);
					strcat(child, "/");
					strcat(child, dir.d_name);
					ret += GetDirCount(child, opt);
					FreeVramAdder(child);
				}
				if(opt & COUNT_DIR)ret++;
			}
			else
				if(opt & COUNT_FILE)ret++;
		}
		memset(&dir, 0, sizeof(SceIoDirent));
	}

	sceIoDclose(dfd);

	return ++ret;
}


int compare_dir_str(const void* c1, const void* c2){
  return strcasecmp(((dir_t *)c1)->type, ((dir_t *)c2)->type);
}


dir_t *read_dir(const char *path, int *file_num){
	int dir_num = GetDirCount(path, COUNT_ALL);
	if(dir_num == 0){
		*file_num = 0;
		return NULL;
	}
	
	dir_t *dir = GetVramAdder(sizeof(dir_t)*dir_num, 4);
	memset(dir, 0, sizeof(dir_t)*dir_num);
	SceUID dp;
	SceIoDirent entry;
	int num = 0;

	dp = sceIoDopen(path);
	if(dp >= 0){
		memset(&entry, 0, sizeof(entry));
		while(sceIoDread(dp, &entry) > 0){
			if((strcmp(&entry.d_name[0], ".") == 0) || (strcmp(&entry.d_name[0], "..") == 0))continue;
			dir[num].type = GetVramAdder(strlen(entry.d_name) + 2, 1);
			dir[num].name = dir[num].type+1;
			strcpy(dir[num].name, entry.d_name);
			switch(entry.d_stat.st_mode & FIO_S_IFMT){
				case FIO_S_IFREG:
					*dir[num].type = TYPE_ETC;
					dir[num].size = entry.d_stat.st_size;
					num ++;
				break;

				case FIO_S_IFDIR:
					dir[num].size = 0;//GetDirSize(child);
					*dir[num].type = TYPE_DIR;
					num++;
				break;
			}
		}
		sceIoDclose(dp);
	}
	qsort(dir, num, sizeof(dir_t), compare_dir_str);
	*file_num = num;
	return dir;
}


//Thanks chitoku!
int getDiskInfo(DiskInfo *info){
	if(sceIoDevctl("ms0:", 0x02425818, &info, 4, NULL, 0) >= 0){
		u64 buf = info->sector_count * info->sector_size;
		info->smax = (u64)info->cluster_max * buf;
		info->sfree = (u64)info->cluster_free * buf;
		info->sused = info->smax - info->sfree;
		return 0;
	}
	else return -1;
}

void DeleteMarkFromFileName(char *str){
	int i, j;
	for(i = 0; str[i] != '\0'; i++){
		if(str[i] == '\\' || str[i] == '/' || str[i] == ':' || str[i] == '*' || str[i] == '?' || str[i] == '\"' || str[i] == '<' || str[i] == '>' || str[i] == '|'){
			for(j = i; str[j] != '\0'; j++)
				str[j] = str[j + 1];
			i--;
		}
	}
}


void FileRename(const char *before){
	char after[256];

	if(OnScreenKeybord(after, 256, PSP_UTILITY_OSK_INPUTTYPE_ALL, "O̕ύX", (char *)(strrchr(before, '/')+1)) == 1){
		DeleteMarkFromFileName(after);	//t@CɎgȂ
		char newpath[512];
		strcpy(newpath, before);
		*(strrchr(newpath, '/') + 1) = '\0';
		strcat(newpath, after);
		if(GetExist(newpath))
			return;

		sceIoRename(before, newpath);
	}
}


void CreateFolder(const char *nowpath){
	char after[256];

	if(OnScreenKeybord(after, 256, PSP_UTILITY_OSK_INPUTTYPE_ALL, "tH_VK쐬", "VtH_") == 1){
		DeleteMarkFromFileName(after);
		char newpath[512];
		strcpy(newpath, nowpath);
		strcat(newpath, "/");
		strcat(newpath, after);
		if(GetExist(newpath))
			return;

		sceIoMkdir(newpath, 0777);
	}
}

int do_dump( char *name, void *addr, int size )
{
        SceUID fd = sceIoOpen(name, PSP_O_CREAT | PSP_O_TRUNC | PSP_O_WRONLY, 0777);
        if(fd < 0)
        {
                return(-1);
        }
        sceIoWrite(fd, addr, size);
       
        sceIoClose(fd);
        return 0;
}


list_t *makeFileList(const char *path, int *file_num, u64 *size_sum, dir_t *dir, int dir_num){
	int makeList(const char *path_, list_t *dir_, int file_num_, u64 *size_sum_){
		SceUID dp;
		SceIoDirent entry;
		
		dp = sceIoDopen(path_);
		if(dp >= 0){
			memset(&entry, 0, sizeof(entry));
			while(sceIoDread(dp, &entry) > 0){
				if((strcmp(&entry.d_name[0], ".") == 0) || (strcmp(&entry.d_name[0], "..") == 0))continue;
				if(*path_ != '\0'){
					dir_[file_num_].name = GetVramAdder(strlen(path_) + strlen(entry.d_name) + 2, 1);
					strcpy(dir_[file_num_].name, path_);
					strcat(dir_[file_num_].name, "/");
					strcat(dir_[file_num_].name, entry.d_name);
				} else {
					dir_[file_num_].name = GetVramAdder(strlen(entry.d_name) + 1, 1);
					strcpy(dir_[file_num_].name, entry.d_name);
				}
				
				dir_[file_num_].stat = entry.d_stat;
				file_num_++;
				switch(entry.d_stat.st_mode & FIO_S_IFMT){
					case FIO_S_IFREG:
					case FIO_S_IFLNK:
						*size_sum_ += entry.d_stat.st_size;
						break;

					case FIO_S_IFDIR:
						file_num_ = makeList(dir_[file_num_-1].name, dir_, file_num_, size_sum_);
						break;
				}
			}
			sceIoDclose(dp);
		}
		return file_num_;
	}
	
	int i, list_num = 0;
	sceIoChdir(path);
	for(i=0; i<dir_num; i++){
		if(dir[i].copy){
			if(*dir[i].type == TYPE_DIR){
				list_num += GetDirCount(dir[i].name, COUNT_ALL)+1;
			} else {
				list_num++;
			}
		}
	}
	list_t *tmp_list = GetVramAdder(sizeof(list_t)*list_num, 4);
	memset(tmp_list, 0, sizeof(list_t)*list_num);
	*size_sum = 0;
	*file_num = 0;
	for(i=0; i<dir_num; i++){
		if(dir[i].copy){
			tmp_list[*file_num].name = GetVramAdder(strlen(dir[i].name) + 1, 1);
			strcpy(tmp_list[*file_num].name, dir[i].name);
			sceIoGetstat(dir[i].name, &tmp_list[*file_num].stat);
			*file_num += 1;
			if(*dir[i].type == TYPE_DIR){
				*file_num = makeList(dir[i].name, tmp_list, *file_num, size_sum);
			} else {
				*size_sum += tmp_list[*file_num-1].stat.st_size;
			}
		}
	}
	int size = (int)tmp_list[*file_num-1].name + strlen(tmp_list[*file_num-1].name) +1 - (int)tmp_list;
	list_t *list = mem_alloc(size);
	memcpy(list, tmp_list, size);
	int gap = (int)list-(int)tmp_list;
	for(i=0; i<*file_num; i++){
		list[i].name = tmp_list[i].name + gap;
	}
	FreeVramAdder(dir);
	return list;
}


bool GetExist(const char *Name){
	SceIoStat stat;
	return sceIoGetstat(Name, &stat) < 0 ? false : true;
}
