#ifndef __IO_LIBRARY__
#define __IO_LIBRARY__

#include "common.h"

#define COPYBUFSIZE 2048
#define MAX_PATH_LEN (256)


typedef enum {
	COUNT_DIR = 0x1,
	COUNT_FILE,//0x2
	COUNT_ALL,//0x3
	COUNT_ONCE//0x4
} COUNT_TYPE;

typedef struct DiskInfo {
	unsigned long cluster_max;	//総クラスタ数
	unsigned long cluster_free;	//空きクラスタ数
	int sector_max;				//きりのいい空きクラスタ数
	int sector_size;			//セクタあたりのバイト数
	int sector_count;			//クラスタあたりのセクタ数
	u64 smax;					//総容量
	u64 sfree;					//空き容量
	u64 sused;					//使用容量
}DiskInfo;

typedef enum {
  TYPE_DIR = '0',
  TYPE_ETC
} file_type;


typedef struct {
  char *type;
  char *name;
  u64 size;
  int read;
} dir_t;


int RemoveDirectory(const char *path);
u64 GetDirSize(const char *Name);
int GetDirCount(const char *Name, COUNT_TYPE opt);
bool GetExist(const char *Name);
int getDiskInfo(DiskInfo *info);
void FileRename(const char *before);
void CreateFolder(const char *nowpath);
int freeFileList(dir_t *dir, int list_num);
dir_t *makeFileList(const char *path, dir_t *dir, int *file_num);
dir_t *read_dir(const char *path, dir_t *dir, int *file_num);


#endif