#ifndef LIBMENU_H
#define LIBMENU_H

#include <stdbool.h>
#include <pspctrl.h>


#ifdef __cplusplus
extern "C" {
#endif


// libmInitBuffers ő1ɎwoVRAMIvV
enum
{
	LIBM_DRAW_INIT8888	= 0x01 ,
	LIBM_DRAW_INIT4444	= 0x02 ,
	LIBM_DRAW_INIT5650	= 0x04 ,
	LIBM_DRAW_INIT5551	= 0x08 ,
	LIBM_DRAW_BLEND		= 0x10 ,
	LIBM_DRAW_RETURN	= 0x20 ,
};

#define	LIBM_FMT_MASK			(LIBM_DRAW_INIT8888 | LIBM_DRAW_INIT4444 | LIBM_DRAW_INIT5650 | LIBM_DRAW_INIT5551)


#define	LIBM_DRAW_INIT			(LIBM_FMT_MASK | LIBM_DRAW_RETURN)

//libmDebugScreenSetXYŎw\X,Y̍ől
#define	LIBM_SETX_MAX			59
#define	LIBM_SETY_MAX			33

// px * 8 ̏Vtgpŏ
#define	LIBM_8PX_POS(px)	((px)<<3)

//libmenutHg̏cTCY
#define LIBM_CHAR_WIDTH			8
#define LIBM_CHAR_HEIGHT		8

#define	LIBM_NO_DRAW			0

#define	LIBM_VIEW_ALL			false
#define	LIBM_VIEW_ACTIVE		true


typedef enum
{
	MenuContainer,
	RadioButton,
	ToggleButton,
	CheckBox,
	Spacer,
	SelectBox,
	UpDownCtrl,
	TriggerButton,
	RadioButtonGroup
} MenuItemType;



// libmGetHandles Action QƂē郁j[̏
typedef enum
{
	Menu_None = 0,	//Ȃ
	Menu_Show,		//j[\ꂽ
	Menu_Up,		//ACeIԂ "" Ɏw肳Ă{^ꂽ
	Menu_Down,		//ACeIԂ "" Ɏw肳Ă{^ꂽ
	Menu_Left,		//ACeIԂ "" Ɏw肳Ă{^ꂽ
	Menu_Right,		//ACeIԂ "E" Ɏw肳Ă{^ꂽ
	Menu_Select,	//ACeIԂ "I" Ɏw肳Ă{^ꂽ
	Menu_Back,		//ACeIԂ "߂" Ɏw肳Ă{^ꂽ
	Menu_Close		//j[ꂽ
} MenuResult;


// libmOptAtype֎w\ȃ^Cvꗗ
typedef enum
{
	LIBM_OPT_NONE,	//
	LIBM_OPT_LIST,	//vO̕ϐ烁j[쐬
	LIBM_OPT_FUNC,	//ϐ𓮓Imۂăj[쐬
} optType;



typedef struct MenuItem
{
	struct MenuItem			*Parent;		//ACe̐e ( NULL = Root )
	struct MenuItem			*Next;			//ACe̎
	struct MenuItem			*Prev;			//ACȇO
	struct MenuItem			*Children;		//ACe̎q
	
	
	const char				*Name;			//ACei\j
	int						Type;			//ACẽ^Cv
	int						actionID;		//ACeIꂽ肵ɁAhandleMenu̕ԋpl֑actionID
	int						Data;			//ACel
	
	bool					Visible;		//ACẻ( ture ,false )
	bool					Disable;		//ACe̗LE 
	
	
	//ANeBũACe`F
	//w肪Ȃ Context ̒ʏF
	
	struct
	{
		u32 				Font;			//tHg
		u32 				Back;			//wi
		u32					Line;			//
	}Color;
	
	
	union
	{
		//WI{^p
		struct MenuItem		*RB_Group;		//O[vւ̃|C^[
		
		//WI{^EO[vp
		struct MenuItem		*Group_Sel;		//I𒆃ACeւ̃|C^[
		
		//Rei[p
		struct
		{
			bool			IsOpen;			//J
			struct MenuItem	*Disp;			//֘Atďԕ\ACeւ̃|C^[
		}CNT;
		
		//`FbN{bNXp
		bool				CB_Checked; 	//I
		
		//Xg{bNXp
		struct
		{
			const char		**List;			//Xgւ̃|C^[
			int				Index;			//I𒆂index
		}SB;
		
		//Abv_Ep
		struct
		{
			float			Now;			//ݒn
			float			Step;			//Stepl (+/-)
			float			Min;			//ŏl
			float			Max;			//ől
			bool			type;			//\^Cv ( true =  , false =  )
		}UD;
		
	}Ctrl;
	
} MenuItem;


typedef struct MenuAction
{
	MenuResult	Action;
	MenuItem	*Item;
} MenuParams;


typedef struct
{
	struct
	{
		//j[pACe瓮Imۂꍇɐݒ
		void* (*malloc_p)(SceSize size) ;
		void  (*free_p) (void *ptr) ;
	}func;
	
	struct
	{
		//j[pACemۂX^bN̕ϐɂꍇɐݒ
		MenuItem *val;
		int size;
	} list;
	
	//j[pACe̊mە@
	optType type;	//LIBM_OPT_LIST => X^bN̕ϐALIBM_OPT_FUNC => Im
	
	int count;
	
} libmOpt;



typedef struct MenuContext
{
	//j[pKey
	struct
	{
		u32 				Show;			//\
		u32					Back;			//A߂
		u32					Select;			//I
		u32					Up;				//ֈړ
		u32					Down;			//ֈړ
		u32					Left;			//ֈړ
		u32					Right;			//Eֈړ
	}HotKey;
	
	struct
	{
		u32					Active_Font;	//ANeBu ACẽtHgF
		u32					Active_Back;	//ANeBu ACe̔wiF
		
		u32					Normal_Font;	//ANeBu ACẽtHgF
		u32					Normal_Back;	//ANeBu ACe̔wiF
		
		u32					Disable_Font;	//ȃACẽtHgF
		u32					Disable_Back;	//ȃACe̔wiF
	}Color;
	
	//j[\Ɋւݒ
	struct
	{
		bool				Type;			//j[̃^Cv ( true = ANeBuȍڂ̂ , false = S )
		bool				AutoReturn;		//j[ŏ㕔EŎ^[邩ǂ
		u32					Lines;			//sԁiftHg = 1A0Ɖ`悪Ɂj
	}MenuInfo;
	
	MenuParams				Params;
	
	bool 					IsOpen;			//j[\ǂ(\A\j
	SceCtrlData				LastState;		//Ah~pAOpbhێ
	MenuItem				*Root;			//rootACeւ̃|C^[
	MenuItem				*Active;		//݃ANeBuȃACeւ̃|C^
	
	libmOpt *opt;
	
} MenuContext;




typedef struct
{
	void	*buffer;	//`Ώۂ̊VRAMAhX
	
	int	width;			//ʕ
	int	height;			//ʍ
	
	int	format;			//sNZtH[}bg
	int	lineWidth;		//ʕi`ɎgĂۂ̕j
	
	int	frameSize;		//1ʂ̃TCY(byte)
	int	lineSize;		//1C̃TCY(byte)
	u8	pixelSize;		//sNZTCY
	int opt;
	
	int psx;
	int psy;
} libm_vram_info;


/*	#########################################################
	#					j[֘A						#
	#########################################################
*/


/*	libmSetActiveItem
    j[ŃANeBuȃACeݒ肷
    
    @param: MenuContext *Context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem *Item
    ANeBuw肷ACew
 */
#define	libmSetActive(Context,Item)		(Context)->Active = Item

/*	libmGetActiveItem
    j[ŃANeBuȃACe擾
    
    @param: MenuContext *Context
    Ώۂ̃j[ ReLXg
    
    @return: ݃ANeBuȃACe (MenuItem*)
 */
#define	libmGetActive(Context)			(Context)->Active


/*	libmIsOpen
    j[̕\/\ Ԃ擾
    
    @param: MenuContext *Context
    Ώۂ̃j[ ReLXg
    
    @return : \/\̏
    false = \Atrue = \
 */
#define libmIsOpen(Context)				(Context)->IsOpen



#define	libmSetLineColor(item,color)	(item)->Color.Line = color

/*	libmIsInvalidItem
    ACeIs (Xy[T[A\Ajȕ𒲂ׂ
    
    @param: MenuItem *Item
    Ώۂ̃ACe
    
    @return : false = IsACeAtrue = I\ACe
 */
bool libmIsInvalidItem(MenuItem *Item);

/*	libmGetPrevItem
    ÕACe
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACe (Xy[T[A\AjOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* libmGetPrevItem( MenuItem *Item , bool Invalid_Skip );


/*	libmGetNextItem
    ̃ACe
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACe (Xy[T[A\AjOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* libmGetNextItem( MenuItem *Item , bool Invalid_Skip );



/*	libmGetBottomItem
    猟ĈԍŌɂACe𒲂ׂ
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACe (Xy[T[A\AjOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* libmGetBottomItem( MenuItem *Item , bool Invalid_Skip );
	

/*	libmGetTopItem
    猟ĈԍŏɂACe𒲂ׂ
    
    @param: MenuItem *Item
    ̊ƂACe
    
    @param: bool Invalid_Skip
    ȃACe (Xy[T[A\AjOČǂ
    
    @return : LȃACeAȂ NULL
 */
MenuItem* libmGetTopItem( MenuItem *Item , bool Invalid_Skip );

/*	libmSetOpt
    j[ contextAitem 쐬̃IvVw
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: libmOpt *opt
	
	EACep̃ϐmۂꍇ͂̂悤ȊŐݒ
	opt.type = LIBM_OPT_LIST;
	opt.list.val	= item_list;			( item_list  MenuItem* ̔z )
	opt.list.size 	= sizeof(item_list);	(opt.list.valŎw肵zTCYj
	libmSetOpt(&opt);
	
	EACep̃𓮓Imۂꍇ͂̂悤ȊŐݒ
	
	
	opt.type = LIBM_OPT_FUNC;
	opt.func.malloc_p	= mۊ֐;
	opt.func.free_p		= ֐;
	libmSetOpt(&opt);
	
    
    @return : ݒoǂ
    false = sAtrue = 
 */

bool libmSetOpt(MenuContext* Context , libmOpt *opt );




/*	libmCreateContext
    j[ ReLXg쐬
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @return: 쐬j[ReLXg
    
    쐬ɐƈȉ̒llƂĎݒ肳
    
	context->HotKey.Show			= PSP_CTRL_NOTE ;
	context->HotKey.Back			= PSP_CTRL_CIRCLE;
	context->HotKey.Select			= PSP_CTRL_CROSS;
	context->HotKey.Up				= PSP_CTRL_UP;
	context->HotKey.Down			= PSP_CTRL_DOWN;
	context->HotKey.Left			= PSP_CTRL_LEFT;
	context->HotKey.Right			= PSP_CTRL_RIGHT;
	
	context->MenuInfo.Type			= false;
	
	context->MenuInfo.AutoReturn	= true;
	
	context->Color.Active_Font		= GREEN;
	context->Color.Normal_Font		= WHITE;
	
	context->Color.Active_Back		= BLACK;
	context->Color.Normal_Back		= Invalid;
	
	context->Color.Disable_Font		= GRAY;
	context->Color.Disable_Back		= Invalid;
	
	context->MenuInfo.Lines		 	= 1;
 */
MenuContext* libmCreateContext(libmOpt *opt);

/*	libmRemoveContext
    j[ ReLXg폜ij
    
    @param: MenuContext* Context
    폜郁j[ReLXg
    
    libmSetOptŃImۂݒ̏ꍇ̂݃
    
 */
void libmRemoveContext(MenuContext* Context);

/*  libmAddItem
    j[ ReLXgɃACeǉ
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem* Parent
    ACeǉΏۂ̐e(ACej
	
    @param: MenuItem* Item
    ǉACe
    
    @param: u32 font_color
    ǉACẽtHgF
    0 w肷ƕ`悵Ȃ
    
    @param: u32 back_color
    ǉACe̔wiF
    0 w肷ƕ`悵Ȃ
    
    @param: int actionID
    ACe삳ꂽہAʂ邽߂ID(ANVj
    
    @param: int Data
    ACe삳ꂽہAʂ邽߂ID(ACeŗLj
    
    @return: 쐬ꂽACe
 */
MenuItem* libmAddItem(MenuContext* Context, MenuItem* Parent, MenuItem* Item,u32 font_color,u32 back_color, int actionID, int Data);

/*	libmRemoveItem
    ACe폜ij
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: MenuItem* Item
    Ώۂ̃ACe
    
    libmSetOptŃImۂݒ̏ꍇ̂݃
    @
    @ΏۂRei[ꍇ́A
    @ɂSACe폜
 */
void libmRemoveItem( MenuContext *context , MenuItem* Item );

/*	libmGetHandle
    j[̓擾i`͂Ȃj
    
    @param: MenuContext* Context
    Ώۂ̃j[ReLXg
    
    @param: SceCtrlData* Input
    Key( SceCtrlData )
    
    @return: MenuParams (IꂽACeAj[̏ԂȂǁj
 */

MenuParams* libmGetHandle(MenuContext* Context, SceCtrlData* Input);

/*  libmRender
    ʂփj[`悷
    
    @param: MenuContext* Context
    Ώۂ̃j[ context
    
    @param:  int PosX
    j[̕\ʒu X
    
    @param: int PosY
    j[̕\ʒu Y
    
    
    j[\ɑXbh~LɂĂꍇ
    \(Xbh~) HOME{^ 
    Q[I\ɂ邽߂ɎőXbhĊJ + j[
 */
void libmRender(MenuContext* Context,int PosX,int PosY ,char *buf ,int bufLen);




/*  libmCreateContainer
    ACe쐬iRei[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Rei
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateContainer(libmOpt *opt ,const char* Name);

/*  libmCreateRadioButton
    ACe쐬iWI{^j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    WI{^
    
    @param: bool State
    I
    
    @param: MenuItem * Group
  @֘At郉WI{^ O[v
  @libmCreateRadioButtonGroupō쐬
  @wK{
  @
	@return : 쐬ꂽACe
	
	libmAddItemŎۂɒǉ鎞́A
	Parent(e)Rei[ ܂ NULLłȂƖ
 */
MenuItem* libmCreateRadioButton(libmOpt *opt ,const char* Name, bool State,MenuItem * Group);

/*  libmCreateRadioButtonGroup
    ACe쐬iWI{^ O[v)
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateRadioButtonGroup(libmOpt *opt);



/*  libmCreateCheckBox
    ACe쐬i`FbN{bNXj
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    `FbN{bNX
    
    @param: bool State
    I
    
	@return : 쐬ꂽACe
 */
MenuItem* libmCreateCheckBox(libmOpt *opt ,const char* Name, bool State);

/*  libmCreateSelectBox
    ACe쐬i`FbN{bNXj
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    ZNg{bNX
    
    @param: const char *List[]
    ZNg{bNXɕ\ACeXg
    const char *̔zAŌNULLKv
    
    @param: int Selected
    XgŏɑIς݂Ƃʒu
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateSelectBox(libmOpt *opt ,const char* Name, const char *List[],int Selected);

/*  libmCreateUpDownCtrl
    ACe쐬iAbv_ERg[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Abv_ERg[
    
    @param: float Now
    ݒl
    
    @param: float Step
    l
    
    @param: float Min
    ŏl
    
    @param: float Max
    ől
    
    @param: bool type
    false = `掞Ɍݒl_\ ( 00.00 ̂悤Ȋj
    true = `掞Ɍݒl𐮐\
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateUpDownCtrl(libmOpt *opt ,const char* Name,float Now,float Step,float Min, float Max,bool type);

/*  libmCreateSpacer
    ACe쐬iXy[T[j
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
    @param: const char* Name
    Xy[T[
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateSpacer(libmOpt *opt ,const char* Name);

/*  libmCreateTriggerButton
    ACe쐬igK[{^)
    
    @param: libmOpt *opt
    Ώۂ̃j[IvV
    
	@param: const char* Name
    gK[{^
    
    @return : 쐬ꂽACe
 */
MenuItem* libmCreateTriggerButton(libmOpt *opt ,const char* Name);



/*	#############################################################
	#							`							#
	#############################################################
*/




/*  libmInitBuffers
    ݂̃fBXvC̏Ԃɍ킹ĕ`揀
    
    @param: int opt
	ۂɐݒ肷`IvV
	ȉLɂݒ
	
	LIBM_DRAW_INIT8888		sNZtH[}bg8888ŏ
	LIBM_DRAW_INIT4444		sNZtH[}bg4444ŏ
	LIBM_DRAW_INIT5650		sNZtH[}bg5650ŏ
	LIBM_DRAW_INIT5551		sNZtH[}bg5551ŏ
	LIBM_DRAW_BLEND			wi߂Lɂ
	LIBM_DRAW_RETURN		`ʒuʊOꍇ͐܂Ԃĕ\
	
	LIBM_DRAW_INIT			sNZtH[}bg8888A͎܂Ԃŉʂ
							ɎAvlibmenu̕`֐ pspDebugScreenXXXX ̗lɎg悤ɂ
    
    @param: int sync
    Ώ
    
	PSP_DISPLAY_SETBUF_IMMEDIATE
	PSP_DISPLAY_SETBUF_NEXTFRAME
	̂ǂ炩w
	
	opt  LIBM_DRAW_INITw肵ꍇ́Async  PSP_DISPLAY_SETBUF_NEXTFRAME w
    
    @return: true = Afalse = s
 */
bool libmInitBuffers( int opt ,int sync );



/*  libmSwapBuffers
    libmRender ŕ`Ɏgobt@[̕ύX
    
	j[\ɃXbh~悤ɐݒ肵ꍇ
	gƃ_uobt@Ô悤ȂƂo邪
	͓KȂ̂ŕςȓ邩Ȃ
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
 */
void libmSwapBuffers();

/*  libmClearBuffers
    libmRender ŕ`Ɏgobt@[NAiFj
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
 */
void libmClearBuffers();


/*  libmPrintXY
	
	libmenu̓tHgg  `悷iWw肠j
	
	@params : int x
	\ʒu X
	
	@params : int y
	\ʒu Y
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : const char *str
    `Ώ 
    
    @return: `悵
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
 */
inline int libmPrintXY( int x, int y, u32 fg, u32 bg, const char *str );



/*  libmPrintfXY
	
	libmenu̓tHgg t `悷iWw肠j
	
	@params : int x
	\ʒu X
	
	@params : int y
	\ʒu Y
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : char *buf
	當𐶐ۂɎgobt@[
	
	@params : int bufLen
	obt@[TCYichar *bufj
	
	@params : format, ...
    `Ώ t 
    
    @return: `悵
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
 */
inline int libmPrintfXY( int x, int y, u32 fg, u32 bg, char *buf ,int bufLen ,const char *format, ... );



/*  libmPutCharXY
	
	libmenu̓tHgg  `悷iWw肠j
	
	@params : int x
	\ʒu X
	
	@params : int y
	\ʒu Y
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : const char *str
    `Ώ 
    
    @return: `悵
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
 */
inline int libmPutCharXY( int x, int y, u32 fg, u32 bg, const char chr );




/*  libmDebugScreenInit
	
	ʂɕ`悷鏀
	pspDebugScreenInit Ǝ悤ȓ
 */
#define	libmDebugScreenInit()		libmInitBuffers(LIBM_DRAW_INIT,PSP_DISPLAY_SETBUF_NEXTFRAME)




/*  libmDebugScreenPrint
	
	libmenu̓tHgg  `悷iWwȂj
	pspDebugScreenPrintf Ǝ悤ȓ
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : const char *str
    `Ώ 
    
    @return: `悵
    
	O libmInitBuffers ܂ libmDebugScreenInit sĂȂƐ퓮삵Ȃ
 */
#define	libmDebugScreenPrint(fg,bg,str)							libmPrintXY(-1,-1,fg,bg,str)



/*  libmDebugScreenPrintf
	
	libmenu̓tHgg t `悷iWwȂj
	pspDebugScreenPrintf Ǝ悤ȓ
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : char *buf
	當𐶐ۂɎgobt@[
	
	@params : int bufLen
	obt@[TCYichar *bufj
	
	@params : format, ...
    `Ώ t 
    
    @return: `悵
    
	O libmInitBuffers ܂ libmDebugScreenInit sĂȂƐ퓮삵Ȃ
 */
#define	libmDebugScreenPrintf(fg,bg,buf,bufLen,format,...)		libmPrintfXY(-1,-1,fg,bg,buf,bufLen,format, __VA_ARGS__)


/*  libmDebugScreenPutChar
	
	libmenu̓tHgg  `悷iWwȂj
	pspDebugScreenPrintf Ǝ悤ȓ
	
	@params : unsigned int fg
	tHgF(32bit)
	0 ƕ`悵Ȃ
	
	@params : unsigned int bg
	wiF(32bit)
	0 ƕ`悵Ȃ
	
	@params : const char *str
    `Ώ 
    
    @return: `悵
    
	O libmInitBuffers ܂ libmDebugScreenInit sĂȂƐ퓮삵Ȃ
 */
#define	libmDebugScreenPutChar(fg,bg,chr)							libmPrintfXY(-1,-1,fg,bg,chr)


/*  libmDebugScreenSetXY
	
	WwȂ̕/`֐
	`Jnʒuw肷
	
	@params : int x
	`JnʒuX@(0 - 59)
	1 8x8 hbgȂ̂1ső60܂
	
	@params : int y
	`JnʒuY@(0 - 33)
	1 8x8 hbgȂ̂1ő34܂
    
    @return: true = Afalse = siX/Yǂ炩̒lُj
 */
bool libmDebugScreenSetXY( int x ,int y );


/*	libmLine
	ʂɐ`悷
	
	@params : int sx
	`JnʒuX
	
	@params : int sy
	`JnʒuY
	
	@params : int ex
	`IʒuX
	
	@params : int ey
	`IʒuY
    
	@params : u32 color
	`F(32bit)
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void libmLine( int sx, int sy, int ex, int ey, u32 color );


/*	libmPoint
	ʂɓ_`悷
	w肵32bitF݂̉ʐݒɍ킹Ďϊ
	
	@params : void *adr
	`悷VRAMAhX
	(libmMakeDrawAddrōWAhX֕ϊ)
	
	@params : u32 color
	`F(32bit)
    
    gp
    
    if( libmInitBuffers(false,PSP_DISPLAY_SETBUF_NEXTFRAME) )
    {
 		//X=50,Y=100̈ʒuɐԂ_`悷
 		void *adr = libmMakeDrawAddr(50,100);
 		u32 color = libmMake32bitColor(255,0,0,255);
    	libmPoint(adr,color);
    }
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void libmPoint( void *adr, u32 src );


/*	libmPointEx
	libmPoint荂ɉʂɓ_`悷iAt@uhȗj
	ʐݒɍ킹ĕϊς݂̐Fw
	
	@params : void *adr
	`悷VRAMAhX
	(libmMakeDrawAddrōWAhX֕ϊ)
	
	@params : u32 color
	ʐݒɍ킹ĕϊς݂̕`F
	
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/


inline void libmPointEx(void *adr, u32 src);


/*	libmFillRect
	w͈͂wFœhԂ
	
	@params : int sx
	JnʒuX (0-480)
	
	@params : int sy
	JnʒuY (0-272)
	
	@params : int ex
	IʒuX (0-480)
	
	@params : int ey
	IʒuY (0-272)
	
	@params : u32 color
	`F(32bit)
	
    
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void libmFillRect( int sx, int sy, int ex, int ey, u32 color );



/*	libmCircle
	ʂɉ~`悷
	
	@params : int x
	JnʒuX (0-480)
	
	@params : int y
	JnʒuY (0-272)
	
	@params : u32 radius
	~̔a
	
	@params : u32 color
	`F(32bit)
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void libmCircle( int x, int y, u32 radius, u32 color );



/*	libmFrame
	ʂɘg`悷
	
	@params : int sx
	JnʒuX (0-480)
	
	@params : int sy
	JnʒuY (0-272)
	
	@params : int ex
	IʒuX (0-480)
	
	@params : int ey
	IʒuY (0-272)
	
	@params : u32 color
	`F(32bit)
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void libmFrame( int sx, int sy, int ex, int ey, u32 color );


/*	libmMakeDrawAddr
	W݂̉ʐݒɍ킹VRAMAhXɕϊ
	
	@params : int x
	`ʒuX (0-480)
	
	@params : int y
	`ʒuY (0-272)
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline void* libmMakeDrawAddr( int x, int y );

/*	libmConvert8888_XXXX
	32bitF(R:8 G:8 B:8 A:8)etH[}bg̐F֕ϊ
	
	@params : u32 src
	ϊ̐F
	
    @return: wtH[}bg֕ϊꂽF
*/


#define libmConvert8888_5650( src )	((((src) & 0x00f80000) >> 8) | (((src) & 0x0000fc00) >> 5) | (((src) & 0x000000f8) >> 3))
#define	libmConvert8888_5551( src )	((( ( (src) >> 24 ) ? 1 : 0 ) << 15) | (((src) & 0x00f80000) >> 9 ) | (((src) & 0x0000f800) >> 6 ) | (((src) & 0x000000f8) >> 3 ))
#define	libmConvert8888_4444( src )	((((src) & 0xf0000000) >> 16) | (((src) & 0x00f00000) >> 12) | (((src) & 0x0000f000) >> 8 ) | (((src) & 0x000000f0) >> 4 ))


/*	libmConvertXXXX_8888
	etH[}bg̐F32bitF(R:8 G:8 B:8 A:8)֕ϊ
	
	@params : u32 src
	ϊ̐F
	
    @return: ϊꂽ32bitF(8888tH[}bg)
*/

#define libmConvert4444_8888( src )	((((src) & 0xf000) << 28) | (((src) & 0xf000) << 24) | (((src) & 0x0f00) << 20) | (((src) & 0x0f00) << 16) | (((src) & 0x00f0) << 12) | (((src) & 0x00f0) << 8 ) | (((src) & 0x000f) << 4 ) | (((src) & 0x000f) << 0 ))
#define libmConvert5551_8888( src )	((((src) & 0x8000) << 16) | (((src) & 0x8000) << 15) | (((src) & 0x8000) << 14) | (((src) & 0x8000) << 13) | (((src) & 0x8000) << 12) | (((src) & 0x8000) << 11) | (((src) & 0x8000) << 10) | (((src) & 0x8000) << 9) | (((src) & 0x7c00) << 9) | (((src) & 0x7000) << 4) | (((src) & 0x03e0) << 6) | (((src) & 0x0380) << 1) | (((src) & 0x001f) << 3) | (((src) & 0x001c) >> 2))
#define libmConvert5650_8888( src )	(0xff000000 | (((src) & 0xf800) << 8) | (((src) & 0xe000) << 3) | (((src) & 0x07e0) << 5) | (((src) & 0x0600) >> 1) | (((src) & 0x001f) << 3) | (((src) & 0x001c) >> 2))



/*	libmAlphaBlendXXXX
	etH[}bg̐F(srcAdst)Ƀuh
	
	@params : u8 alpha
	uhAt@l (0-255)
	
	@params : src
	uhFij
	sNZtH[}bgɍ킹ĕϊς݂̐F
	
	@params : dst
	uhFij
	sNZtH[}bgɍ킹ĕϊς݂̐F
	
	@params : ret
	ʂ󂯎ϐ
	
    @return: uhꂽF
*/

inline u32 libmAlphaBlend8888( u8 alpha, u32 src, u32 dst );
inline u32 libmAlphaBlend4444( u8 alpha, u32 src, u32 dst );
inline u32 libmAlphaBlend5551( u8 alpha, u32 src, u32 dst );
inline u32 libmAlphaBlend5650( u8 alpha, u32 src, u32 dst );

/*	libmMake32bitColor
	RGBA32bit(8888tH[}bg)̐F𐶐
	
	@params : u8 R
	Color Red (0-255)
	
	@params : u8 G
	Color Green (0-255)
	
	@params : u8 B
	Color Blue (0-255)
	
	@params : u8 A
	Alpha (0-255)
	
	@return : 8888tH[}bg32bitF
*/
#define	libmMake32bitColor(R,G,B,A)	 ((R & 255) | ((G & 255) << 8) | ((B & 255) << 16) | ((A & 255) << 24))


/*	libmGetColor
	w肵WXY`F擾
	
	@params : int x
	WX(0-480)
	
	@params : int y
	WX(0-272)
	
	@return : w肵W瓾F
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
inline u32 libmGetColor(void *addr);


/*	libmGetCurVInfo
	libmenu e`֐ŎgĂ錻݂̊eݒ擾
	擾oɂĂ libm_vram_info ̒`Q
	
	@params : libm_vram_info *info
	擾̕ϐ
	
	@return : true = Afalse = s
	
	O libmInitBuffers sĂȂƐ퓮삵Ȃ
*/
bool libmGetCurVInfo(libm_vram_info *info);


/*	libmSetCurVInfo
	libmenu e`֐ŎgĂ錻݂̐ݒύX
	
	@params : format
	sNZtH[}bg
	
	@params : buf
	`̊VRAMAhX
	
	@params : width
	`敝
*/
void libmSetCurVInfo(int format, void *buf, int width);




#ifdef __cplusplus
}
#endif

#endif
