//ゆうさんのPSPTreeExplorer_1.1fixより


#include <psputility.h>
#include <string.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include "common.h"

unsigned int __attribute__((aligned(16)))	list[1000];


void guStart(){
	sceGuStart(GU_DIRECT, list);
}

void guEnd(){
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();
}

void initGraphics(){

	sceGuInit();

	guStart();
	sceGuDrawBuffer(GU_PSM_4444,(void*)0x44000,BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH,SCR_HEIGHT,(void*)0,BUF_WIDTH);
	sceGuDepthBuffer((void*)0x88000,BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2),2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048,2048,SCR_WIDTH,SCR_HEIGHT);
	sceGuDepthRange(0xc350,0x2710);
	sceGuScissor(0,0,SCR_WIDTH,SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_FLAT);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_TEXTURE_2D);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuFinish();
	sceGuSync(0,0);

	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
}



int OnScreenKeybord(char *buf, int buflen, int mode, const char *title, const char *init){
	if(!buf)
		return -1;

	u16 *winit, *wtitle, *wresult;
	char nulstr[] = "";
	if(!init)
		init = nulstr;
	if(!title)
		title = nulstr;
	winit = GetVramAdder((strlen(init) + 1) * 2, 2);
	wtitle = GetVramAdder((strlen(title) + 1) * 2, 2);
	wresult = GetVramAdder((buflen + 1) * 2, 2);
	if(!winit){
		FreeVramAdder(winit);
		return -1;
	}

	sjis_to_utf16(winit, init);
	sjis_to_utf16(wtitle, title);

	SceUtilityOskData data;
	memset(&data, 0, sizeof(SceUtilityOskData));
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &data.language);
	data.unk_00 = 1;	//ATOK
	data.lines = 1;
	data.unk_24 = 1;
	data.inputtype = mode;
	data.desc = wtitle;
	data.intext = winit;
	data.outtextlength = buflen;
	data.outtextlimit = buflen;
	data.outtext = wresult;

	SceUtilityOskParams params;
	memset(&params, 0, sizeof(params));
	params.base.size = sizeof(params);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &params.base.language);
	sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &params.base.buttonSwap);
	params.base.graphicsThread = 0x11;
	params.base.accessThread = 0x13;
	params.base.fontThread = 0x12;
	params.base.soundThread = 0x10;
	params.datacount = 1;
	params.data = &data;

	sceUtilityOskInitStart(&params);

	int done = 0;

	
	while(!done)
	{
		guStart();
		sceGuClearColor(0);
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		guEnd();

		switch(sceUtilityOskGetStatus()){
		case PSP_UTILITY_DIALOG_NONE:
			break;
		case PSP_UTILITY_DIALOG_INIT:
			break;
		case PSP_UTILITY_DIALOG_VISIBLE:
			sceUtilityOskUpdate(1);
			break;
		case PSP_UTILITY_DIALOG_QUIT:
			sceUtilityOskShutdownStart();
			break;
		case PSP_UTILITY_DIALOG_FINISHED:
			done = 1;
			break;
		default:
			break;
		}
		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}
	sceGuDrawBuffer(GU_PSM_4444, (void*)0x44000, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0, BUF_WIDTH);

	utf16_to_sjis(buf, wresult);

	FreeVramAdder(winit);

	switch(data.result)
	{
	case PSP_UTILITY_OSK_RESULT_UNCHANGED:
	case PSP_UTILITY_OSK_RESULT_CANCELLED:
		{
			return 0;
		}
	case PSP_UTILITY_OSK_RESULT_CHANGED:
		{
			return 1;
		}
	}

	return -1;
}

